package jess;

import java.util.Iterator;

/**
 * (C) 2005 Sandia National Laboratories<BR>
 * $Id: IntMarkerImpl.java,v 1.1 2005/10/06 17:31:09 ejfried Exp $
 */
class IntMarkerImpl implements WorkingMemoryMarker {
    private int m_factId;

    IntMarkerImpl(int factId) {
        m_factId = factId;
    }

    public void restore(Rete engine) throws JessException {
        synchronized (engine.getCompiler()) {
            for (Iterator it = engine.listFacts(); it.hasNext();) {
                Fact fact = (Fact) it.next();
                if (m_factId <= fact.getFactId())
                    engine.retract(fact);
            }
        }
    }
}
